/************************************************************************/
/*      H8S/2638 Series Include File                       Ver 2.1      */
/************************************************************************/
struct st_hcan {                                        /* struct HCAN  */
               union {                                  /* MCR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char SLPMR:1;      /*    SLPMR     */
                            unsigned char      :1;      /*              */
                            unsigned char SLPM :1;      /*    SLPM      */
                            unsigned char      :2;      /*              */
                            unsigned char MTM  :1;      /*    MTM       */
                            unsigned char HLTRQ:1;      /*    HLTRQ     */
                            unsigned char RSTRQ:1;      /*    RSTRQ     */
                            }      BIT;                 /*              */
                     }          MCR;                    /*              */
               union {                                  /* GSR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char     :4;       /*              */
                            unsigned char RSB :1;       /*    RSB       */
                            unsigned char MTSF:1;       /*    MTSF      */
                            unsigned char TRWF:1;       /*    TRWF      */
                            unsigned char BOF :1;       /*    BOF       */
                            }      BIT;                 /*              */
                     }          GSR;                    /*              */
               union {                                  /* BCR          */
                     unsigned short WORD;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char SJW  :2;      /*    SJW       */
                            unsigned char BRP  :6;      /*    BRP       */
                            unsigned char BSP  :1;      /*    BSP       */
                            unsigned char TSEG2:3;      /*    TSEG2     */
                            unsigned char TSEG1:4;      /*    TSEG1     */
                            }       BIT;                /*              */
                     }          BCR;                    /*              */
               union {                                  /* MBCR         */
                     unsigned short WORD;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char     :1;       /*              */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                            }       BIT;                /*              */
                     }          MBCR;                   /*              */
               union {                                  /* TXPR         */
                     unsigned short WORD;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char     :1;       /*              */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                            }       BIT;                /*              */
                     }          TXPR;                   /*              */
               union {                                  /* TXCR         */
                     unsigned short WORD;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char     :1;       /*              */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                            }       BIT;                /*              */
                     }          TXCR;                   /*              */
               union {                                  /* TXACK        */
                     unsigned short WORD;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char     :1;       /*              */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                            }       BIT;                /*              */
                     }          TXACK;                  /*              */
               union {                                  /* ABACK        */
                     unsigned short WORD;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char     :1;       /*              */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                            }       BIT;                /*              */
                     }          ABACK;                  /*              */
               union {                                  /* RXPR         */
                     unsigned short WORD;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char MB0 :1;       /*    MB0       */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                            }       BIT;                /*              */
                     }          RXPR;                   /*              */
               union {                                  /* RFPR         */
                     unsigned short WORD;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char MB0 :1;       /*    MB0       */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                            }       BIT;                /*              */
                     }          RFPR;                   /*              */
               union {                                  /* IRR          */
                     unsigned short WORD;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char OLFIF:1;      /*    OLFIF     */
                            unsigned char BOFIF:1;      /*    BOFIF     */
                            unsigned char EPIF :1;      /*    EPIF      */
                            unsigned char ROWIF:1;      /*    ROWIF     */
                            unsigned char TOWIF:1;      /*    TOWIF     */
                            unsigned char RFRIF:1;      /*    RFRIF     */
                            unsigned char RMIF :1;      /*    RMIF      */
                            unsigned char RSTIF:1;      /*    RSTIF     */
                            unsigned char      :3;      /*              */
                            unsigned char BOIF :1;      /*    BOIF      */
                            unsigned char      :2;      /*              */
                            unsigned char URIF :1;      /*    URIF      */
                            unsigned char MBEIF:1;      /*    MBEIF     */
                            }       BIT;                /*              */
                     }          IRR;                    /*              */
               union {                                  /* MBIMR        */
                     unsigned short WORD;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char MB0 :1;       /*    MB0       */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                            }       BIT;                /*              */
                     }          MBIMR;                  /*              */
               union {                                  /* IMR          */
                     unsigned short WORD;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char OLFIM:1;      /*    OLFIM     */
                            unsigned char BOFIM:1;      /*    BOFIM     */
                            unsigned char EPIM :1;      /*    EPIM      */
                            unsigned char ROWIM:1;      /*    ROWIM     */
                            unsigned char TOWIM:1;      /*    TOWIM     */
                            unsigned char RFRIM:1;      /*    RFRIM     */
                            unsigned char RMIM :1;      /*    RMIM      */
                            unsigned char      :1;      /*              */
                            unsigned char      :3;      /*              */
                            unsigned char BOIM :1;      /*    BOIM      */
                            unsigned char      :2;      /*              */
                            unsigned char URIM :1;      /*    URIM      */
                            unsigned char MBEIM:1;      /*    MBEIM     */
                            }       BIT;                /*              */
                     }          IMR;                    /*              */
               unsigned char    REC;                    /* REC          */
               unsigned char    TEC;                    /* TEC          */
               union {                                  /* UMSR         */
                     unsigned short WORD;               /*  Word Access */
                     struct {                           /*  Bit  Access */
                            unsigned char MB7 :1;       /*    MB7       */
                            unsigned char MB6 :1;       /*    MB6       */
                            unsigned char MB5 :1;       /*    MB5       */
                            unsigned char MB4 :1;       /*    MB4       */
                            unsigned char MB3 :1;       /*    MB3       */
                            unsigned char MB2 :1;       /*    MB2       */
                            unsigned char MB1 :1;       /*    MB1       */
                            unsigned char MB0 :1;       /*    MB0       */
                            unsigned char MB15:1;       /*    MB15      */
                            unsigned char MB14:1;       /*    MB14      */
                            unsigned char MB13:1;       /*    MB13      */
                            unsigned char MB12:1;       /*    MB12      */
                            unsigned char MB11:1;       /*    MB11      */
                            unsigned char MB10:1;       /*    MB10      */
                            unsigned char MB9 :1;       /*    MB9       */
                            unsigned char MB8 :1;       /*    MB8       */
                            }       BIT;                /*              */
                     }          UMSR;                   /*              */
               union {                                  /* LAFML        */
                     unsigned short WORD;               /*  Word Access */
                     struct {                           /*  Byte Access */
                            unsigned char L;            /*    Low       */
                            unsigned char H;            /*    High      */
                            }       BYTE;               /*              */
                     }          LAFML;                  /*              */
               union {                                  /* LAFMH        */
                     unsigned short WORD;               /*  Word Access */
                     struct {                           /*  Byte Access */
                            unsigned char L;            /*    Low       */
                            unsigned char H;            /*    High      */
                            }       BYTE;               /*              */
                     }          LAFMH;                  /*              */
               unsigned char    MC[16][8];              /* MC[x][y]     */
               char             wk[16];                 /*              */
               unsigned char    MD[16][8];              /* MD[x][y]     */
};                                                      /*              */
struct st_pwm1 {                                        /* struct PWM1  */
               union {                                  /* PWCR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char    :2;        /*              */
                            unsigned char IE :1;        /*    IE        */
                            unsigned char CMF:1;        /*    CMF       */
                            unsigned char CST:1;        /*    CST       */
                            unsigned char CKS:3;        /*    CKS       */
                            }      BIT;                 /*              */
                     }          PWCR;                   /*              */
               char             wk1;                    /*              */
               union {                                  /* PWOCR        */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char OEH:1;        /*    OEH       */
                            unsigned char OEG:1;        /*    OEG       */
                            unsigned char OEF:1;        /*    OEF       */
                            unsigned char OEE:1;        /*    OEE       */
                            unsigned char OED:1;        /*    OED       */
                            unsigned char OEC:1;        /*    OEC       */
                            unsigned char OEB:1;        /*    OEB       */
                            unsigned char OEA:1;        /*    OEA       */
                            }      BIT;                 /*              */
                     }          PWOCR;                  /*              */
               char             wk2;                    /*              */
               union {                                  /* PWPR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char OPSH:1;       /*    OPSH      */
                            unsigned char OPSG:1;       /*    OPSG      */
                            unsigned char OPSF:1;       /*    OPSF      */
                            unsigned char OPSE:1;       /*    OPSE      */
                            unsigned char OPSD:1;       /*    OPSD      */
                            unsigned char OPSC:1;       /*    OPSC      */
                            unsigned char OPSB:1;       /*    OPSB      */
                            unsigned char OPSA:1;       /*    OPSA      */
                            }      BIT;                 /*              */
                     }          PWPR;                   /*              */
               char             wk3;                    /*              */
               unsigned int     PWCYR;                  /* PWCYR        */
               unsigned int     PWBFRA;                 /* PWBFRA       */
               unsigned int     PWBFRC;                 /* PWBFRC       */
               unsigned int     PWBFRE;                 /* PWBFRE       */
               unsigned int     PWBFRG;                 /* PWBFRG       */
};                                                      /*              */
struct st_pwm2 {                                        /* struct PWM2  */
               union {                                  /* PWCR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char    :2;        /*              */
                            unsigned char IE :1;        /*    IE        */
                            unsigned char CMF:1;        /*    CMF       */
                            unsigned char CST:1;        /*    CST       */
                            unsigned char CKS:3;        /*    CKS       */
                            }      BIT;                 /*              */
                     }          PWCR;                   /*              */
               char             wk1;                    /*              */
               union {                                  /* PWOCR        */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char OEH:1;        /*    OEH       */
                            unsigned char OEG:1;        /*    OEG       */
                            unsigned char OEF:1;        /*    OEF       */
                            unsigned char OEE:1;        /*    OEE       */
                            unsigned char OED:1;        /*    OED       */
                            unsigned char OEC:1;        /*    OEC       */
                            unsigned char OEB:1;        /*    OEB       */
                            unsigned char OEA:1;        /*    OEA       */
                            }      BIT;                 /*              */
                     }          PWOCR;                  /*              */
               char             wk2;                    /*              */
               union {                                  /* PWPR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char OPSH:1;       /*    OPSH      */
                            unsigned char OPSG:1;       /*    OPSG      */
                            unsigned char OPSF:1;       /*    OPSF      */
                            unsigned char OPSE:1;       /*    OPSE      */
                            unsigned char OPSD:1;       /*    OPSD      */
                            unsigned char OPSC:1;       /*    OPSC      */
                            unsigned char OPSB:1;       /*    OPSB      */
                            unsigned char OPSA:1;       /*    OPSA      */
                            }      BIT;                 /*              */
                     }          PWPR;                   /*              */
               char             wk3;                    /*              */
               unsigned int     PWCYR;                  /* PWCYR        */
               unsigned int     PWBFRA;                 /* PWBFRA       */
               unsigned int     PWBFRB;                 /* PWBFRB       */
               unsigned int     PWBFRC;                 /* PWBFRC       */
               unsigned int     PWBFRD;                 /* PWBFRD       */
};                                                      /*              */
union un_scrx {                                         /* union SCRX   */
              unsigned char BYTE;                       /*  Byte Access */
              struct {                                  /*  Bit  Access */
                     unsigned char      :1;             /*              */
                     unsigned char IICX1:1;             /*    IICX1     */
                     unsigned char IICX0:1;             /*    IICX0     */
                     unsigned char IICE :1;             /*    IICE      */
                     }      BIT;                        /*              */
};                                                      /*              */
union un_ddcswr {                                       /* union DDCSWR */
                unsigned char BYTE;                     /*  Byte Access */
                struct {                                /*  Bit  Access */
                       unsigned char    :4;             /*              */
                       unsigned char CLR:4;             /*    CLR       */
                       }      BIT;                      /*              */
};                                                      /*              */
union un_sbycr {                                        /* union SBYCR  */
               unsigned char BYTE;                      /*  Byte Access */
               struct {                                 /*  Bit  Access */
                      unsigned char SSBY:1;             /*    SSBY      */
                      unsigned char STS :3;             /*    STS       */
                      unsigned char OPE :1;             /*    OPE       */
                      }      BIT;                       /*              */
};                                                      /*              */
union un_syscr {                                        /* union SYSCR  */
               unsigned char BYTE;                      /*  Byte Access */
               struct {                                 /*  Bit  Access */
                      unsigned char MACS :1;            /*    MACS      */
                      unsigned char      :1;            /*              */
                      unsigned char INTM :2;            /*    INTM      */
                      unsigned char NMIEG:1;            /*    NMIEG     */
                      unsigned char      :2;            /*              */
                      unsigned char RAME :1;            /*    RAME      */
                      }      BIT;                       /*              */
};                                                      /*              */
union un_sckcr {                                        /* union SCKCR  */
               unsigned char BYTE;                      /*  Byte Access */
               struct {                                 /*  Bit  Access */
                      unsigned char PSTOP:1;            /*    PSTOP     */
                      unsigned char      :3;            /*              */
                      unsigned char STCS :1;            /*    STCS      */
                      unsigned char SCK  :3;            /*    SCK       */
                      }      BIT;                       /*              */
};                                                      /*              */
union un_mdcr {                                         /* union MDCR   */
              unsigned char BYTE;                       /*  Byte Access */
              struct {                                  /*  Bit  Access */
                     unsigned char    :5;               /*              */
                     unsigned char MDS:3;               /*    MDS       */
                     }      BIT;                        /*              */
};                                                      /*              */
struct st_mstp {                                        /* struct MSTP  */
               union {                                  /* CRD          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char _PWM:1;       /*    PWM       */
                            }      BIT;                 /*              */
                     }          CRD;                    /*              */
               char             wk[391];                /*              */
               union {                                  /* CRA          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char     :1;       /*              */
                            unsigned char _DTC:1;       /*    DTC       */
                            unsigned char _TPU:1;       /*    TPU       */
                            unsigned char     :1;       /*              */
                            unsigned char _PPG:1;       /*    PPG       */
                            unsigned char _DA :1;       /*    D/A       */
                            unsigned char _AD :1;       /*    A/D       */
                            }      BIT;                 /*              */
                     }          CRA;                    /*              */
               union {                                  /* CRB          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char _SCI0:1;      /*    SCI0      */
                            unsigned char _SCI1:1;      /*    SCI1      */
                            unsigned char _SCI2:1;      /*    SCI2      */
                            unsigned char _IIC0:1;      /*    IIC0      */
                            unsigned char _IIC1:1;      /*    IIC1      */
                            }      BIT;                 /*              */
                     }          CRB;                    /*              */
               union {                                  /* CRC          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char       :3;     /*              */
                            unsigned char _PBC  :1;     /*    PBC       */
                            unsigned char _HCAN0:1;     /*    HCAN0     */
                            unsigned char _HCAN1:1;     /*    HCAN1     */
                            }      BIT;                 /*              */
                     }          CRC;                    /*              */
};                                                      /*              */
union un_lpwrcr {                                       /* union LPWRCR */
                unsigned char BYTE;                     /*  Byte Access */
                struct {                                /*  Bit  Access */
                       unsigned char DTON  :1;          /*    DTON      */
                       unsigned char LSON  :1;          /*    LSON      */
                       unsigned char NESEL :1;          /*    NESEL     */
                       unsigned char SUBSTP:1;          /*    SUBSTP    */
                       unsigned char RFCUT :1;          /*    RFCUT     */
                       unsigned char       :1;          /*              */
                       unsigned char STC   :2;          /*    STC       */
                       }      BIT;                      /*              */
};                                                      /*              */
struct st_pbc {                                         /* struct PBC   */
              void             *BARA;                   /* BARA         */
              void             *BARB;                   /* BARB         */
              union {                                   /* BCRA         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CMFA :1;       /*    CMFA      */
                           unsigned char CDA  :1;       /*    CDA       */
                           unsigned char BAMRA:3;       /*    BAMRA     */
                           unsigned char CSELA:2;       /*    CSELA     */
                           unsigned char BIEA :1;       /*    BIEA      */
                           }      BIT;                  /*              */
                    }           BCRA;                   /*              */
              union {                                   /* BCRB         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CMFB :1;       /*    CMFB      */
                           unsigned char CDB  :1;       /*    CDB       */
                           unsigned char BAMRB:3;       /*    BAMRB     */
                           unsigned char CSELB:2;       /*    CSELB     */
                           unsigned char BIEB :1;       /*    BIEB      */
                           }      BIT;                  /*              */
                    }           BCRB;                   /*              */
};                                                      /*              */
struct st_dtc {                                         /* struct DTC   */
              union {                                   /* DTCEA        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char IRQ0:1;        /*    IRQ0      */
                           unsigned char IRQ1:1;        /*    IRQ1      */
                           unsigned char IRQ2:1;        /*    IRQ2      */
                           unsigned char IRQ3:1;        /*    IRQ3      */
                           unsigned char IRQ4:1;        /*    IRQ4      */
                           unsigned char IRQ5:1;        /*    IRQ5      */
                           }      BIT;                  /*              */
                    }           DTCEA;                  /*              */
              union {                                   /* DTCEB        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char      :1;       /*              */
                           unsigned char ADI  :1;       /*    ADI       */
                           unsigned char TGI0A:1;       /*    TGI0A     */
                           unsigned char TGI0B:1;       /*    TGI0B     */
                           unsigned char TGI0C:1;       /*    TGI0C     */
                           unsigned char TGI0D:1;       /*    TGI0D     */
                           unsigned char TGI1A:1;       /*    TGI1A     */
                           unsigned char TGI1B:1;       /*    TGI1B     */
                           }      BIT;                  /*              */
                    }           DTCEB;                  /*              */
              union {                                   /* DTCEC        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char TGI2A:1;       /*    TGI2A     */
                           unsigned char TGI2B:1;       /*    TGI2B     */
                           unsigned char TGI3A:1;       /*    TGI3A     */
                           unsigned char TGI3B:1;       /*    TGI3B     */
                           unsigned char TGI3C:1;       /*    TGI3C     */
                           unsigned char TGI3D:1;       /*    TGI3D     */
                           unsigned char TGI4A:1;       /*    TGI4A     */
                           unsigned char TGI4B:1;       /*    TGI4B     */
                           }      BIT;                  /*              */
                    }           DTCEC;                  /*              */
              union {                                   /* DTCED        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char      :2;       /*              */
                           unsigned char TGI5A:1;       /*    TGI5A     */
                           unsigned char TGI5B:1;       /*    TGI5B     */
                           }      BIT;                  /*              */
                    }           DTCED;                  /*              */
              union {                                   /* DTCEE        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char     :4;        /*              */
                           unsigned char RXI0:1;        /*    RXI0      */
                           unsigned char TXI0:1;        /*    TXI0      */
                           unsigned char RXI1:1;        /*    RXI1      */
                           unsigned char TXI1:1;        /*    TXI1      */
                           }      BIT;                  /*              */
                    }           DTCEE;                  /*              */
              union {                                   /* DTCEF        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char RXI2 :1;       /*    RXI2      */
                           unsigned char TXI2 :1;       /*    TXI2      */
                           unsigned char      :4;       /*              */
                           unsigned char IICI0:1;       /*    IICI0     */
                           unsigned char IICI1:1;       /*    IICI1     */
                           }      BIT;                  /*              */
                    }           DTCEF;                  /*              */
              union {                                   /* DTCEG        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CMI1:1;        /*    CMI1      */
                           unsigned char CMI2:1;        /*    CMI2      */
                           unsigned char     :1;        /*              */
                           unsigned char RM00:1;        /*    RM0       */
                           unsigned char     :1;        /*              */
                           unsigned char RM01:1;        /*    RM0       */
                           }      BIT;                  /*              */
                    }           DTCEG;                  /*              */
              char              wk[2];                  /*              */
              union {                                   /* DTVECR       */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char SWDTE:1;       /*    SWDTE     */
                           unsigned char DTVEC:7;       /*    DTVEC     */
                           }      BIT;                  /*              */
                    }           DTVECR;                 /*              */
};                                                      /*              */
struct st_ppg {                                         /* struct PPG   */
              union {                                   /* PCR          */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char G3CMS:2;       /*    G3CMS     */
                           unsigned char G2CMS:2;       /*    G2CMS     */
                           }      BIT;                  /*              */
                    }           PCR;                    /*              */
              union {                                   /* PMR          */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char G3INV:1;       /*    G3INV     */
                           unsigned char G2INV:1;       /*    G2INV     */
                           unsigned char      :2;       /*              */
                           unsigned char G3NOV:1;       /*    G3NOV     */
                           unsigned char G2NOV:1;       /*    G2NOV     */
                           }      BIT;                  /*              */
                    }           PMR;                    /*              */
              union {                                   /* NDER         */
                    unsigned int WORD;                  /*  Word Access */
                    struct {                            /*  Bit  Access */
                           unsigned char H;             /*    NDERH     */
                           unsigned char L;             /*    NDERL     */
                           }     BYTE;                  /*              */
                    struct {                            /*  Bit  Access */
                           unsigned char B15:1;         /*    NDER15    */
                           unsigned char B14:1;         /*    NDER14    */
                           unsigned char B13:1;         /*    NDER13    */
                           unsigned char B12:1;         /*    NDER12    */
                           unsigned char B11:1;         /*    NDER11    */
                           unsigned char B10:1;         /*    NDER10    */
                           unsigned char B9 :1;         /*    NDER9     */
                           unsigned char B8 :1;         /*    NDER8     */
                           unsigned char B7 :1;         /*    NDER7     */
                           unsigned char B6 :1;         /*    NDER6     */
                           unsigned char B5 :1;         /*    NDER5     */
                           unsigned char B4 :1;         /*    NDER4     */
                           unsigned char B3 :1;         /*    NDER3     */
                           unsigned char B2 :1;         /*    NDER2     */
                           unsigned char B1 :1;         /*    NDER1     */
                           unsigned char B0 :1;         /*    NDER0     */
                           }      BIT;                  /*              */
                    }           NDER;                   /*              */
              union {                                   /* PODR         */
                    unsigned int WORD;                  /*  Word Access */
                    struct {                            /*  Bit  Access */
                           unsigned char H;             /*    PODRH     */
                           unsigned char L;             /*    PODRL     */
                           }     BYTE;                  /*              */
                    struct {                            /*  Bit  Access */
                           unsigned char B15:1;         /*    NDER15    */
                           unsigned char B14:1;         /*    NDER14    */
                           unsigned char B13:1;         /*    NDER13    */
                           unsigned char B12:1;         /*    NDER12    */
                           unsigned char B11:1;         /*    NDER11    */
                           unsigned char B10:1;         /*    NDER10    */
                           unsigned char B9 :1;         /*    NDER9     */
                           unsigned char B8 :1;         /*    NDER8     */
                           unsigned char B7 :1;         /*    NDER7     */
                           unsigned char B6 :1;         /*    NDER6     */
                           unsigned char B5 :1;         /*    NDER5     */
                           unsigned char B4 :1;         /*    NDER4     */
                           unsigned char B3 :1;         /*    NDER3     */
                           unsigned char B2 :1;         /*    NDER2     */
                           unsigned char B1 :1;         /*    NDER1     */
                           unsigned char B0 :1;         /*    NDER0     */
                           }     BIT;                   /*              */
                    }           PODR;                   /*              */
              union {                                   /* NDRH (H'2C)  */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char B15:1;         /*    NDR15     */
                           unsigned char B14:1;         /*    NDR14     */
                           unsigned char B13:1;         /*    NDR13     */
                           unsigned char B12:1;         /*    NDR12     */
                           unsigned char B11:1;         /*    NDR11     */
                           unsigned char B10:1;         /*    NDR10     */
                           unsigned char B9 :1;         /*    NDR9      */
                           unsigned char B8 :1;         /*    NDR8      */
                           }      BIT;                  /*              */
                    }           NDRH1;                  /*              */
              union {                                   /* NDRL (H'2D)  */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char B7:1;          /*    NDR7      */
                           unsigned char B6:1;          /*    NDR6      */
                           unsigned char B5:1;          /*    NDR5      */
                           unsigned char B4:1;          /*    NDR4      */
                           unsigned char B3:1;          /*    NDR3      */
                           unsigned char B2:1;          /*    NDR2      */
                           unsigned char B1:1;          /*    NDR1      */
                           unsigned char B0:1;          /*    NDR0      */
                           }      BIT;                  /*              */
                    }           NDRL1;                  /*              */
              union {                                   /* NDRH (H'2E)  */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char    :4;         /*              */
                           unsigned char B11:1;         /*    NDR11     */
                           unsigned char B10:1;         /*    NDR10     */
                           unsigned char B9 :1;         /*    NDR9      */
                           unsigned char B8 :1;         /*    NDR8      */
                           }      BIT;                  /*              */
                    }           NDRH2;                  /*              */
              union {                                   /* NDRL (H'2F)  */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char   :4;          /*              */
                           unsigned char B3:1;          /*    NDR3      */
                           unsigned char B2:1;          /*    NDR2      */
                           unsigned char B1:1;          /*    NDR1      */
                           unsigned char B0:1;          /*    NDR0      */
                           }      BIT;                  /*              */
                    }           NDRL2;                  /*              */
};                                                      /*              */
struct st_p1 {                                          /* struct P1    */
             unsigned char      DDR;                    /* P1DDR        */
             char               wk1[207];               /*              */
             union {                                    /* P1DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
             char               wk2[175];               /*              */
             union {                                    /* P1PORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_p3 {                                          /* struct P3    */
             unsigned char      DDR;                    /* P3DDR        */
             char               wk1[19];                /*              */
             union {                                    /* P3ODR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :2;           /*              */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            ODR;                    /*              */
             char               wk2[187];               /*              */
             union {                                    /* P3DR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :2;           /*              */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
             char               wk3[175];               /*              */
             union {                                    /* P3PORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :2;           /*              */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_p4 {                                          /* struct P4    */
             union {                                    /* P4PORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_p9 {                                          /* struct P9    */
             union {                                    /* P9PORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :4;           /*              */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_pa {                                          /* struct PA    */
             unsigned char      DDR;                    /* PADDR        */
             char               wk1[6];                 /*              */
             union {                                    /* PAPCR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :4;           /*              */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
             char               wk2[6];                 /*              */
             union {                                    /* PAODR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :4;           /*              */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            ODR;                    /*              */
             char               wk3[193];               /*              */
             union {                                    /* PADR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :4;           /*              */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
             char               wk4[175];               /*              */
             union {                                    /* PAPORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char   :4;           /*              */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_pb {                                          /* struct PB    */
             unsigned char      DDR;                    /* PBDDR        */
             char               wk1[6];                 /*              */
             union {                                    /* PBPCR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
             char               wk2[6];                 /*              */
             union {                                    /* PBODR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            ODR;                    /*              */
             char               wk3[193];               /*              */
             union {                                    /* PBDR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
             char               wk4[175];               /*              */
             union {                                    /* PBPORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_pc {                                          /* struct PC    */
             unsigned char      DDR;                    /* PCDDR        */
             char               wk1[6];                 /*              */
             union {                                    /* PCPCR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
             char               wk2[6];                 /*              */
             union {                                    /* PCODR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            ODR;                    /*              */
             char               wk3[193];               /*              */
             union {                                    /* PCDR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
             char               wk4[175];               /*              */
             union {                                    /* PCPORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_pd {                                          /* struct PD    */
             unsigned char      DDR;                    /* PDDDR        */
             char               wk1[6];                 /*              */
             union {                                    /* PDPCR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
             char               wk2[200];               /*              */
             union {                                    /* PDDR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
             char               wk3[175];               /*              */
             union {                                    /* PDPORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_pe {                                          /* struct PE    */
             unsigned char      DDR;                    /* PEDDR        */
             char               wk1[6];                 /*              */
             union {                                    /* PEPCR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
             char               wk2[200];               /*              */
             union {                                    /* PEDR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
             char               wk3[175];               /*              */
             union {                                    /* PEPORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_pf {                                          /* struct PF    */
             unsigned char      DDR;                    /* PFDDR        */
             char               wk1[207];               /*              */
             union {                                    /* PFDR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char   :2;           /*              */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
             char               wk2[175];               /*              */
             union {                                    /* PFPORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char   :2;           /*              */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_ph {                                          /* struct PH    */
             unsigned char      DDR;                    /* PHDDR        */
             char               wk1[3];                 /*              */
             union {                                    /* PHDR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
             char               wk2[3];                 /*              */
             union {                                    /* PHPORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_pj {                                          /* struct PJ    */
             unsigned char      DDR;                    /* PJDDR        */
             char               wk1[3];                 /*              */
             union {                                    /* PJDR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
             char               wk2[3];                 /*              */
             union {                                    /* PJPORT       */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char B7:1;           /*    Bit 7     */
                          unsigned char B6:1;           /*    Bit 6     */
                          unsigned char B5:1;           /*    Bit 5     */
                          unsigned char B4:1;           /*    Bit 4     */
                          unsigned char B3:1;           /*    Bit 3     */
                          unsigned char B2:1;           /*    Bit 2     */
                          unsigned char B1:1;           /*    Bit 1     */
                          unsigned char B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PORT;                   /*              */
};                                                      /*              */
struct st_tpu {                                         /* struct TPU   */
              union {                                   /* TSTR         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char     :2;        /*              */
                           unsigned char CST5:1;        /*    CST5      */
                           unsigned char CST4:1;        /*    CST4      */
                           unsigned char CST3:1;        /*    CST3      */
                           unsigned char CST2:1;        /*    CST2      */
                           unsigned char CST1:1;        /*    CST1      */
                           unsigned char CST0:1;        /*    CST0      */
                           }      BIT;                  /*              */
                    }           TSTR;                   /*              */
              union {                                   /* TSYR         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char      :2;       /*              */
                           unsigned char SYNC5:1;       /*    SYNC5     */
                           unsigned char SYNC4:1;       /*    SYNC4     */
                           unsigned char SYNC3:1;       /*    SYNC3     */
                           unsigned char SYNC2:1;       /*    SYNC2     */
                           unsigned char SYNC1:1;       /*    SYNC1     */
                           unsigned char SYNC0:1;       /*    SYNC0     */
                           }      BIT;                  /*              */
                    }           TSYR;                   /*              */
};                                                      /*              */
struct st_tpu0 {                                        /* struct TPU0  */
               union {                                  /* TCR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char CCLR:3;       /*    CCLR      */
                            unsigned char CKEG:2;       /*    CKEG      */
                            unsigned char TPSC:3;       /*    TPSC      */
                            }      BIT;                 /*              */
                     }          TCR;                    /*              */
               union {                                  /* TMDR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char    :2;        /*              */
                            unsigned char BFB:1;        /*    BFB       */
                            unsigned char BFA:1;        /*    BFA       */
                            unsigned char MD :4;        /*    MD        */
                            }      BIT;                 /*              */
                     }          TMDR;                   /*              */
               union {                                  /* TIOR         */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Byte Access */
                            unsigned char H;            /*    TIORH     */
                            unsigned char L;            /*    TIORL     */
                            }     BYTE;                 /*              */
                     struct {                           /*  Bit  Access */
                            unsigned char IOB:4;        /*    IOB       */
                            unsigned char IOA:4;        /*    IOA       */
                            unsigned char IOD:4;        /*    IOD       */
                            unsigned char IOC:4;        /*    IOC       */
                            }     BIT;                  /*              */
                     }          TIOR;                   /*              */
               union {                                  /* TIER         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char TTGE :1;      /*    TTGE      */
                            unsigned char      :2;      /*              */
                            unsigned char TCIEV:1;      /*    TCIEV     */
                            unsigned char TGIED:1;      /*    TGIED     */
                            unsigned char TGIEC:1;      /*    TGIEC     */
                            unsigned char TGIEB:1;      /*    TGIEB     */
                            unsigned char TGIEA:1;      /*    TGIEA     */
                            }      BIT;                 /*              */
                     }          TIER;                   /*              */
               union {                                  /* TSR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char     :3;       /*              */
                            unsigned char TCFV:1;       /*    TCFV      */
                            unsigned char TGFD:1;       /*    TGFD      */
                            unsigned char TGFC:1;       /*    TGFC      */
                            unsigned char TGFB:1;       /*    TGFB      */
                            unsigned char TGFA:1;       /*    TGFA      */
                            }      BIT;                 /*              */
                     }          TSR;                    /*              */
               unsigned int     TCNT;                   /* TCNT         */
               unsigned int     TGRA;                   /* TGRA         */
               unsigned int     TGRB;                   /* TGRB         */
               unsigned int     TGRC;                   /* TGRC         */
               unsigned int     TGRD;                   /* TGRD         */
};                                                      /*              */
struct st_tpu1 {                                        /* struct TPU1  */
               union {                                  /* TCR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char     :1;       /*              */
                            unsigned char CCLR:2;       /*    CCLR      */
                            unsigned char CKEG:2;       /*    CKEG      */
                            unsigned char TPSC:3;       /*    TPSC      */
                            }      BIT;                 /*              */
                     }          TCR;                    /*              */
               union {                                  /* TMDR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char   :4;         /*              */
                            unsigned char MD:4;         /*    MD        */
                            }      BIT;                 /*              */
                     }          TMDR;                   /*              */
               union {                                  /* TIOR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char IOB:4;        /*    IOB       */
                            unsigned char IOA:4;        /*    IOA       */
                            }      BIT;                 /*              */
                     }          TIOR;                   /*              */
               char             wk;                     /*              */
               union {                                  /* TIER         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char TTGE :1;      /*    TTGE      */
                            unsigned char      :1;      /*              */
                            unsigned char TCIEU:1;      /*    TCIEU     */
                            unsigned char TCIEV:1;      /*    TCIEV     */
                            unsigned char      :2;      /*              */
                            unsigned char TGIEB:1;      /*    TGIEB     */
                            unsigned char TGIEA:1;      /*    TGIEA     */
                            }      BIT;                 /*              */
                     }          TIER;                   /*              */
               union {                                  /* TSR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char TCFD:1;       /*    TCFD      */
                            unsigned char     :1;       /*              */
                            unsigned char TCFU:1;       /*    TCFU      */
                            unsigned char TCFV:1;       /*    TCFV      */
                            unsigned char     :2;       /*              */
                            unsigned char TGFB:1;       /*    TGFB      */
                            unsigned char TGFA:1;       /*    TGFA      */
                            }      BIT;                 /*              */
                     }          TSR;                    /*              */
               unsigned int     TCNT;                   /* TCNT         */
               unsigned int     TGRA;                   /* TGRA         */
               unsigned int     TGRB;                   /* TGRB         */
};                                                      /*              */
struct st_intc {                                        /* struct INTC  */
               union {                                  /* ISCR         */
                     unsigned int WORD;                 /*  Word Access */
                     struct {                           /*  Byte Access */
                            unsigned char H;            /*    ISCRH     */
                            unsigned char L;            /*    ISCRL     */
                            }     BYTE;                 /*              */
                     struct {                           /*  Bit  Access */
                            unsigned char       :4;     /*              */
                            unsigned char IRQ5SC:2;     /*    IRQ5SC    */
                            unsigned char IRQ4SC:2;     /*    IRQ4SC    */
                            unsigned char IRQ3SC:2;     /*    IRQ3SC    */
                            unsigned char IRQ2SC:2;     /*    IRQ2SC    */
                            unsigned char IRQ1SC:2;     /*    IRQ1SC    */
                            unsigned char IRQ0SC:2;     /*    IRQ0SC    */
                            }     BIT;                  /*              */
                     }          ISCR;                   /*              */
               union {                                  /* IER          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char      :2;      /*              */
                            unsigned char IRQ5E:1;      /*    IRQ5E     */
                            unsigned char IRQ4E:1;      /*    IRQ4E     */
                            unsigned char IRQ3E:1;      /*    IRQ3E     */
                            unsigned char IRQ2E:1;      /*    IRQ2E     */
                            unsigned char IRQ1E:1;      /*    IRQ1E     */
                            unsigned char IRQ0E:1;      /*    IRQ0E     */
                            }      BIT;                 /*              */
                     }          IER;                    /*              */
               union {                                  /* ISR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char      :2;      /*              */
                            unsigned char IRQ5F:1;      /*    IRQ5F     */
                            unsigned char IRQ4F:1;      /*    IRQ4F     */
                            unsigned char IRQ3F:1;      /*    IRQ3F     */
                            unsigned char IRQ2F:1;      /*    IRQ2F     */
                            unsigned char IRQ1F:1;      /*    IRQ1F     */
                            unsigned char IRQ0F:1;      /*    IRQ0F     */
                            }      BIT;                 /*              */
                     }          ISR;                    /*              */
               char             wk1[170];               /*              */
               union {                                  /* IPRA         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char      :1;      /*              */
                            unsigned char _IRQ0:3;      /*    IRQ0      */
                            unsigned char      :1;      /*              */
                            unsigned char _IRQ1:3;      /*    IRQ1      */
                            }      BIT;                 /*              */
                     }          IPRA;                   /*              */
               union {                                  /* IPRB         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char       :1;     /*              */
                            unsigned char _IRQ23:3;     /*    IRQ2,IRQ3 */
                            unsigned char       :1;     /*              */
                            unsigned char _IRQ45:3;     /*    IRQ4,IRQ5 */
                            }      BIT;                 /*              */
                     }          IPRB;                   /*              */
               union {                                  /* IPRC         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char     :5;       /*              */
                            unsigned char _DTC:3;       /*    DTC       */
                            }      BIT;                 /*              */
                     }          IPRC;                   /*              */
               union {                                  /* IPRD         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char      :1;      /*              */
                            unsigned char _WDT0:3;      /*    WDT0      */
                            }      BIT;                 /*              */
                     }          IPRD;                   /*              */
               union {                                  /* IPRE         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char     :1;       /*              */
                            unsigned char _PBC:3;       /*    PBC       */
                            unsigned char     :1;       /*              */
                            unsigned char _AD :3;       /*    A/D,WDT1  */
                            }      BIT;                 /*              */
                     }          IPRE;                   /*              */
               union {                                  /* IPRF         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char      :1;      /*              */
                            unsigned char _TPU0:3;      /*    TPU0      */
                            unsigned char      :1;      /*              */
                            unsigned char _TPU1:3;      /*    TPU1      */
                            }      BIT;                 /*              */
                     }          IPRF;                   /*              */
               union {                                  /* IPRG         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char      :1;      /*              */
                            unsigned char _TPU2:3;      /*    TPU2      */
                            unsigned char      :1;      /*              */
                            unsigned char _TPU3:3;      /*    TPU3      */
                            }      BIT;                 /*              */
                     }          IPRG;                   /*              */
               union {                                  /* IPRH         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char      :1;      /*              */
                            unsigned char _TPU4:3;      /*    TPU4      */
                            unsigned char      :1;      /*              */
                            unsigned char _TPU5:3;      /*    TPU5      */
                            }      BIT;                 /*              */
                     }          IPRH;                   /*              */
               char             wk2;                    /*              */
               union {                                  /* IPRJ         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char      :5;      /*              */
                            unsigned char _SCI0:3;      /*    SCI0      */
                            }      BIT;                 /*              */
                     }          IPRJ;                   /*              */
               union {                                  /* IPRK         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char      :1;      /*              */
                            unsigned char _SCI1:3;      /*    SCI1      */
                            unsigned char      :1;      /*              */
                            unsigned char _SCI2:3;      /*    SCI2      */
                            }      BIT;                 /*              */
                     }          IPRK;                   /*              */
               union {                                  /* IPRL         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char     :5;       /*              */
                            unsigned char _IIC:3;       /*    IIC       */
                            }      BIT;                 /*              */
                     }          IPRL;                   /*              */
               union {                                  /* IPRM         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char       :1;     /*              */
                            unsigned char _HCAN1:3;     /*    PWM,HCAN1 */
                            unsigned char       :1;     /*              */
                            unsigned char _HCAN0:3;     /*    HCAN0     */
                            }      BIT;                 /*              */
                     }          IPRM;                   /*              */
};                                                      /*              */
struct st_bsc {                                         /* struct BSC   */
              char              wk1;                    /*              */
              union {                                   /* PFCR         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char    :4;         /*              */
                           unsigned char AE3:1;         /*    AE3       */
                           unsigned char AE2:1;         /*    AE2       */
                           unsigned char AE1:1;         /*    AE1       */
                           unsigned char AE0:1;         /*    AE0       */
                           }      BIT;                  /*              */
                    }           PFCR;                   /*              */
              char              wk2[228];               /*              */
              union {                                   /* ABWCR        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char ABW7:1;        /*    ABW7      */
                           unsigned char ABW6:1;        /*    ABW6      */
                           unsigned char ABW5:1;        /*    ABW5      */
                           unsigned char ABW4:1;        /*    ABW4      */
                           unsigned char ABW3:1;        /*    ABW3      */
                           unsigned char ABW2:1;        /*    ABW2      */
                           unsigned char ABW1:1;        /*    ABW1      */
                           unsigned char ABW0:1;        /*    ABW0      */
                           }      BIT;                  /*              */
                    }           ABWCR;                  /*              */
              union {                                   /* ASTCR        */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char AST7:1;        /*    AST7      */
                           unsigned char AST6:1;        /*    AST6      */
                           unsigned char AST5:1;        /*    AST5      */
                           unsigned char AST4:1;        /*    AST4      */
                           unsigned char AST3:1;        /*    AST3      */
                           unsigned char AST2:1;        /*    AST2      */
                           unsigned char AST1:1;        /*    AST1      */
                           unsigned char AST0:1;        /*    AST0      */
                           }      BIT;                  /*              */
                    }           ASTCR;                  /*              */
              union {                                   /* WCR          */
                    unsigned int WORD;                  /*  Word Access */
                    struct {                            /*  Byte Access */
                           unsigned char H;             /*    WCRH      */
                           unsigned char L;             /*    WCRL      */
                           }     BYTE;                  /*              */
                    struct {                            /*  Bit  Access */
                           unsigned char W7:2;          /*    W7        */
                           unsigned char W6:2;          /*    W6        */
                           unsigned char W5:2;          /*    W5        */
                           unsigned char W4:2;          /*    W4        */
                           unsigned char W3:2;          /*    W3        */
                           unsigned char W2:2;          /*    W2        */
                           unsigned char W1:2;          /*    W1        */
                           unsigned char W0:2;          /*    W0        */
                           }     BIT;                   /*              */
                    }           WCR;                    /*              */
              union {                                   /* BCR          */
                    unsigned int WORD;                  /*  Word Access */
                    struct {                            /*  Byte Access */
                           unsigned char H;             /*    BCRH      */
                           unsigned char L;             /*    BCRL      */
                           }     BYTE;                  /*              */
                    struct {                            /*  Bit  Access */
                           unsigned char ICIS1 :1;      /*    ICIS1     */
                           unsigned char ICIS0 :1;      /*    ICIS0     */
                           unsigned char BRSTRM:1;      /*    BRSTRM    */
                           unsigned char BRSTS1:1;      /*    BRSTS1    */
                           unsigned char BRSTS0:1;      /*    BRSTS0    */
                           unsigned char       :3;      /*              */
                           unsigned char       :6;      /*              */
                           unsigned char WDBE  :1;      /*    WDBE      */
                           }     BIT;                   /*              */
                    }           BCR;                    /*              */
};                                                      /*              */
union un_wdt0 {                                         /* union WDT    */
              struct {                                  /* Read  Access */
                     union {                            /* TCSR         */
                           unsigned char BYTE;          /*  Byte Access */
                           struct {                     /*  Bit  Access */
                                  unsigned char OVF :1; /*    OVF       */
                                  unsigned char WTIT:1; /*    WT/IT     */
                                  unsigned char TME :1; /*    TME       */
                                  unsigned char     :2; /*              */
                                  unsigned char CKS :3; /*    CKS       */
                                  }      BIT;           /*              */
                           }       TCSR;                /*              */
                     unsigned char TCNT;                /* TCNT         */
                     char          wk;                  /*              */
                     union {                            /* RSTCSR       */
                           unsigned char BYTE;          /*  Byte Access */
                           struct {                     /*              */
                                  unsigned char WRST:1; /*    WSRT      */
                                  unsigned char RSTE:1; /*    RSTE      */
                                  unsigned char RSTS:1; /*    RSTS      */
                                  }      BIT;           /*              */
                           }       RSTCSR;              /*              */
                     } READ;                            /*              */
              struct {                                  /* Write Access */
                     unsigned int  TCSR;                /* TCSR/TCNT    */
                     unsigned int  RSTCSR;              /* RSTCSR       */
                     } WRITE;                           /*              */
};                                                      /*              */
union un_wdt1 {                                         /* union WDT1   */
              struct {                                  /* Read  Access */
                     union {                            /* TCSR         */
                           unsigned char BYTE;          /*  Byte Access */
                           struct {                     /*  Bit  Access */
                                  unsigned char OVF   :1;/*   OVF       */
                                  unsigned char WTIT  :1;/*   WT/IT     */
                                  unsigned char TME   :1;/*   TME       */
                                  unsigned char PSS   :1;/*   PSS       */
                                  unsigned char RSTNMI:1;/*   RST/NMI   */
                                  unsigned char CKS   :3;/*   CKS       */
                                  }      BIT;           /*              */
                           }       TCSR;                /*              */
                     unsigned char TCNT;                /* TCNT         */
                     } READ;                            /*              */
              struct {                                  /* Write Access */
                     unsigned int  TCSR;                /* TCSR/TCNT    */
                     } WRITE;                           /*              */
};                                                      /*              */
struct st_sci {                                         /* struct SCI   */
              union {                                   /* SMR          */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char CA  :1;        /*    C/A       */
                           unsigned char CHR :1;        /*    CHR       */
                           unsigned char _PE :1;        /*    PE        */
                           unsigned char OE  :1;        /*    O/E       */
                           unsigned char STOP:1;        /*    STOP      */
                           unsigned char MP  :1;        /*    MP        */
                           unsigned char CKS :2;        /*    CKS       */
                           }      BIT;                  /*              */
                    }           SMR;                    /*              */
              unsigned char     BRR;                    /* BRR          */
              union {                                   /* SCR          */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char TIE :1;        /*    TIE       */
                           unsigned char RIE :1;        /*    RIE       */
                           unsigned char TE  :1;        /*    TE        */
                           unsigned char RE  :1;        /*    RE        */
                           unsigned char MPIE:1;        /*    MPIE      */
                           unsigned char TEIE:1;        /*    TEIE      */
                           unsigned char CKE :2;        /*    CKE       */
                           }      BIT;                  /*              */
                    }           SCR;                    /*              */
              unsigned char     TDR;                    /* TDR          */
              union {                                   /* SSR          */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char TDRE:1;        /*    TDRE      */
                           unsigned char RDRF:1;        /*    RDRF      */
                           unsigned char ORER:1;        /*    ORER      */
                           unsigned char FER :1;        /*    FER       */
                           unsigned char PER :1;        /*    PER       */
                           unsigned char TEND:1;        /*    TEND      */
                           unsigned char MPB :1;        /*    MPB       */
                           unsigned char MPBT:1;        /*    MPBT      */
                           }      BIT;                  /*              */
                    }           SSR;                    /*              */
              unsigned char     RDR;                    /* RDR          */
              union {                                   /* SCMR         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char     :4;        /*              */
                           unsigned char SDIR:1;        /*    SDIR      */
                           unsigned char SINV:1;        /*    SINV      */
                           unsigned char     :1;        /*              */
                           unsigned char SMIF:1;        /*    SMIF      */
                           }      BIT;                  /*              */
                    }           SCMR;                   /*              */
};                                                      /*              */
struct st_smci {                                        /* struct SMCI  */
               union {                                  /* SMR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char GM :1;        /*    GM        */
                            unsigned char BLK:1;        /*    BLK       */
                            unsigned char _PE:1;        /*    PE        */
                            unsigned char OE :1;        /*    O/E       */
                            unsigned char BCP:2;        /*    BCP       */
                            unsigned char CKS:2;        /*    CKS       */
                            }      BIT;                 /*              */
                     }          SMR;                    /*              */
               unsigned char    BRR;                    /* BRR          */
               union {                                  /* SCR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char TIE :1;       /*    TIE       */
                            unsigned char RIE :1;       /*    RIE       */
                            unsigned char TE  :1;       /*    TE        */
                            unsigned char RE  :1;       /*    RE        */
                            unsigned char MPIE:1;       /*    MPIE      */
                            unsigned char TEIE:1;       /*    TEIE      */
                            unsigned char CKE :2;       /*    CKE       */
                            }      BIT;                 /*              */
                     }          SCR;                    /*              */
               unsigned char    TDR;                    /* TDR          */
               union {                                  /* SSR          */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char TDRE:1;       /*    TDRE      */
                            unsigned char RDRF:1;       /*    RDRF      */
                            unsigned char ORER:1;       /*    ORER      */
                            unsigned char ERS :1;       /*    ERS       */
                            unsigned char PER :1;       /*    PER       */
                            unsigned char TEND:1;       /*    TEND      */
                            unsigned char MPB :1;       /*    MPB       */
                            unsigned char MPBT:1;       /*    MPBT      */
                            }      BIT;                 /*              */
                     }          SSR;                    /*              */
               unsigned char    RDR;                    /* RDR          */
               union {                                  /* SCMR         */
                     unsigned char BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            unsigned char     :4;       /*              */
                            unsigned char SDIR:1;       /*    SDIR      */
                            unsigned char SINV:1;       /*    SINV      */
                            unsigned char     :1;       /*              */
                            unsigned char SMIF:1;       /*    SMIF      */
                            }      BIT;                 /*              */
                     }          SCMR;                   /*              */
};                                                      /*              */
struct st_iic {                                         /* struct IIC   */
              union {                                   /* ICCR         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char ICE :1;        /*    ICE       */
                           unsigned char IEIC:1;        /*    IEIC      */
                           unsigned char MST :1;        /*    MST       */
                           unsigned char TRS :1;        /*    TRS       */
                           unsigned char ACKE:1;        /*    ACKE      */
                           unsigned char BBSY:1;        /*    BBSY      */
                           unsigned char IRIC:1;        /*    IRIC      */
                           unsigned char SCP :1;        /*    SCP       */
                           }      BIT;                  /*              */
                    }           ICCR;                   /*              */
              union {                                   /* ICSR         */
                    unsigned char BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           unsigned char ESTP:1;        /*    ESTP      */
                           unsigned char STOP:1;        /*    STOP      */
                           unsigned char IRTR:1;        /*    IRTR      */
                           unsigned char AASX:1;        /*    AASX      */
                           unsigned char AL  :1;        /*    AL        */
                           unsigned char AAS :1;        /*    AAS       */
                           unsigned char ADZ :1;        /*    ADZ       */
                           unsigned char ACKB:1;        /*    ACKB      */
                           }      BIT;                  /*              */
                    }           ICSR;                   /*              */
              char              wk[4];                  /*              */
              union {                                   /*              */
                    struct {                            /*              */
                           union {                      /* SARX         */
                                 unsigned char BYTE;    /*  Byte Access */
                                 struct {               /*  Bit  Access */
                                        unsigned char SVAX:7; /* SVAX   */
                                        unsigned char FSX :1; /* FSX    */
                                        }      BIT;     /*              */
                                 } UN_SARX;             /*              */
                           union {                      /* SAR          */
                                 unsigned char BYTE;    /*  Byte Access */
                                 struct {               /*  Bit  Access */
                                        unsigned char SVA:7; /* SVA     */
                                        unsigned char FS :1; /* FS      */
                                        }      BIT;     /*              */
                                 } UN_SAR;              /*              */
                           } ICE0;                      /*              */
                    struct {                            /*              */
                           unsigned char UN_ICDR;       /* ICDR         */
                           union {                      /* ICMR         */
                                 unsigned char BYTE;    /*  Byte Access */
                                 struct {               /*  Bit  Access */
                                        unsigned char MLS :1; /* MLS    */
                                        unsigned char WAIT:1; /* WAIT   */
                                        unsigned char CKS :3; /* CKS    */
                                        unsigned char BC  :3; /* BC     */
                                        }      BIT;     /*              */
                                 }       UN_ICMR;       /*              */
                           } ICE1;                      /*              */
                    }           EQU;                    /*              */
};                                                      /*              */
struct st_ad {                                          /* struct A/D   */
             unsigned int       ADDRA;                  /* ADDRA        */
             unsigned int       ADDRB;                  /* ADDRB        */
             unsigned int       ADDRC;                  /* ADDRC        */
             unsigned int       ADDRD;                  /* ADDRD        */
             union {                                    /* ADCSR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char ADF :1;         /*    ADF       */
                          unsigned char ADIE:1;         /*    ADIE      */
                          unsigned char ADST:1;         /*    ADST      */
                          unsigned char SCAN:1;         /*    SCAN      */
                          unsigned char CH  :4;         /*    CH        */
                          }      BIT;                   /*              */
                   }            ADCSR;                  /*              */
             union {                                    /* ADCR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char TRGS:2;         /*    TRGS      */
                          unsigned char     :2;         /*              */
                          unsigned char CKS :2;         /*    CKS       */
                          }      BIT;                   /*              */
                   }            ADCR;                   /*              */
};                                                      /*              */
struct st_da {                                          /* struct D/A   */
             unsigned char      DADR0;                  /* DADR0        */
             unsigned char      DADR1;                  /* DADR1        */
             union {                                    /* DACR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char DAOE1:1;        /*    DAOE1     */
                          unsigned char DAOE0:1;        /*    DAOE0     */
                          unsigned char DAE  :1;        /*    DAE       */
                          }      BIT;                   /*              */
                   }            DACR;                   /*              */
};                                                      /*              */
struct st_flash {                                       /* struct FLASH */
                union {                                 /* RAMER        */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char     :4;      /*              */
                             unsigned char RAMS:1;      /*    RAMS      */
                             unsigned char RAM :3;      /*    RAM       */
                             }      BIT;                /*              */
                      }         RAMER;                  /*              */
                char            wk[204];                /*              */
                union {                                 /* FLMCR1       */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char FWE:1;       /*    FWE       */
                             unsigned char SWE:1;       /*    SWE       */
                             unsigned char ESU:1;       /*    ESU       */
                             unsigned char PSU:1;       /*    PSU       */
                             unsigned char EV :1;       /*    EV        */
                             unsigned char PV :1;       /*    PV        */
                             unsigned char E  :1;       /*    E         */
                             unsigned char P  :1;       /*    P         */
                             }      BIT;                /*              */
                      }         FLMCR1;                 /*              */
                union {                                 /* FLMCR2       */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char FLER:1;      /*    FLER      */
                             }      BIT;                /*              */
                      }         FLMCR2;                 /*              */
                union {                                 /* EBR1         */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char EB7:1;       /*    EB7       */
                             unsigned char EB6:1;       /*    EB6       */
                             unsigned char EB5:1;       /*    EB5       */
                             unsigned char EB4:1;       /*    EB4       */
                             unsigned char EB3:1;       /*    EB3       */
                             unsigned char EB2:1;       /*    EB2       */
                             unsigned char EB1:1;       /*    EB1       */
                             unsigned char EB0:1;       /*    EB0       */
                             }      BIT;                /*              */
                      }         EBR1;                   /*              */
                union {                                 /* EBR2         */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char     :4;      /*              */
                             unsigned char EB11:1;      /*    EB11      */
                             unsigned char EB10:1;      /*    EB10      */
                             unsigned char EB9 :1;      /*    EB9       */
                             unsigned char EB8 :1;      /*    EB8       */
                             }      BIT;                /*              */
                      }         EBR2;                   /*              */
                union {                                 /* FLPWCR       */
                      unsigned char BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             unsigned char PDWND:1;     /*    PDWND     */
                             }      BIT;                /*              */
                      }         FLPWCR;                 /*              */
};                                                      /*              */
#define HCAN0   (*(volatile struct st_hcan  *)0xFFF800) /* HCAN0 Address*/
#define HCAN1   (*(volatile struct st_hcan  *)0xFFFA00) /* HCAN1 Address*/
#define PWM1    (*(volatile struct st_pwm1  *)0xFFFC00) /* PWM1  Address*/
#define PWM2    (*(volatile struct st_pwm2  *)0xFFFC10) /* PWM2  Address*/
#define SCRX    (*(volatile union  un_scrx  *)0xFFFDB4) /* SCRX  Address*/
#define DDCSWR  (*(volatile union  un_ddcswr*)0xFFFDB5) /* DDCSWRAddress*/
#define SBYCR   (*(volatile union  un_sbycr *)0xFFFDE4) /* SBYCR Address*/
#define SYSCR   (*(volatile union  un_syscr *)0xFFFDE5) /* SYSCR Address*/
#define SCKCR   (*(volatile union  un_sckcr *)0xFFFDE6) /* SCKCR Address*/
#define MDCR    (*(volatile union  un_mdcr  *)0xFFFDE7) /* MDCR  Address*/
#define MSTP    (*(volatile struct st_mstp  *)0xFFFC60) /* MSTP  Address*/
#define LPWRCR  (*(volatile union  un_lpwrcr*)0xFFFDEC) /* LPWRCRAddress*/
#define PBC     (*(volatile struct st_pbc   *)0xFFFE00) /* PBC   Address*/
#define DTC     (*(volatile struct st_dtc   *)0xFFFE16) /* DTC   Address*/
#define PPG     (*(volatile struct st_ppg   *)0xFFFE26) /* PPG   Address*/
#define P1      (*(volatile struct st_p1    *)0xFFFE30) /* P1    Address*/
#define P3      (*(volatile struct st_p3    *)0xFFFE32) /* P3    Address*/
#define P4      (*(volatile struct st_p4    *)0xFFFFB3) /* P4    Address*/
#define P9      (*(volatile struct st_p9    *)0xFFFFB8) /* P9    Address*/
#define PA      (*(volatile struct st_pa    *)0xFFFE39) /* PA    Address*/
#define PB      (*(volatile struct st_pb    *)0xFFFE3A) /* PB    Address*/
#define PC      (*(volatile struct st_pc    *)0xFFFE3B) /* PC    Address*/
#define PD      (*(volatile struct st_pd    *)0xFFFE3C) /* PD    Address*/
#define PE      (*(volatile struct st_pe    *)0xFFFE3D) /* PE    Address*/
#define PF      (*(volatile struct st_pf    *)0xFFFE3E) /* PF    Address*/
#define PH      (*(volatile struct st_ph    *)0xFFFC20) /* PH    Address*/
#define PJ      (*(volatile struct st_pj    *)0xFFFC21) /* PJ    Address*/
#define TPU     (*(volatile struct st_tpu   *)0xFFFEB0) /* TPU   Address*/
#define TPU0    (*(volatile struct st_tpu0  *)0xFFFF10) /* TPU0  Address*/
#define TPU1    (*(volatile struct st_tpu1  *)0xFFFF20) /* TPU1  Address*/
#define TPU2    (*(volatile struct st_tpu1  *)0xFFFF30) /* TPU2  Address*/
#define TPU3    (*(volatile struct st_tpu0  *)0xFFFE80) /* TPU3  Address*/
#define TPU4    (*(volatile struct st_tpu1  *)0xFFFE90) /* TPU4  Address*/
#define TPU5    (*(volatile struct st_tpu1  *)0xFFFEA0) /* TPU5  Address*/
#define INTC    (*(volatile struct st_intc  *)0xFFFE12) /* INTC  Address*/
#define BSC     (*(volatile struct st_bsc   *)0xFFFDEA) /* BSC   Address*/
#define WDT0    (*(volatile union  un_wdt0  *)0xFFFF74) /* WDT0  Address*/
#define WDT1    (*(volatile union  un_wdt1  *)0xFFFFA2) /* WDT1  Address*/
#define SCI0    (*(volatile struct st_sci   *)0xFFFF78) /* SCI0  Address*/
#define SCI1    (*(volatile struct st_sci   *)0xFFFF80) /* SCI1  Address*/
#define SCI2    (*(volatile struct st_sci   *)0xFFFF88) /* SCI2  Address*/
#define SMCI0   (*(volatile struct st_smci  *)0xFFFF78) /* SMCI0 Address*/
#define SMCI1   (*(volatile struct st_smci  *)0xFFFF80) /* SMCI1 Address*/
#define SMCI2   (*(volatile struct st_smci  *)0xFFFF88) /* SMCI2 Address*/
#define IIC0    (*(volatile struct st_iic   *)0xFFFF78) /* IIC0  Address*/
#define IIC1    (*(volatile struct st_iic   *)0xFFFF80) /* IIC1  Address*/
#define ICDR    EQU.ICE1.UN_ICDR                        /* ICDR  Change */
#define ICMR    EQU.ICE1.UN_ICMR                        /* ICDR  Change */
#define SAR     EQU.ICE0.UN_SAR                         /* SAR   Change */
#define SARX    EQU.ICE0.UN_SARX                        /* SARX  Change */
#define AD      (*(volatile struct st_ad    *)0xFFFF90) /* A/D   Address*/
#define DA      (*(volatile struct st_da    *)0xFFFFA4) /* D/A   Address*/
#define FLASH   (*(volatile struct st_flash *)0xFFFEDB) /* FLASH Address*/
