// --------------------------------------------------------------------------------
//   H8/2638 fobOvO
//       QlFlTX@H8/300H TinyV[Y@[U[htbV
//                 H8/3664F    RJJ06B0474-0100/Rev.1.00 2004.09
//       RpCF@KPIT Gcc
// --------------------------------------------------------------------------------
#include	"functions.h"
#include 	"2638s.h"
#include	"def_hard.h"

// ---------------------------------
//   	^`
// ---------------------------------
typedef	void			(*Func)(void);

// ---------------------------------
//   	V{
// ---------------------------------
/******  WAIT TIME  *****************************************/
#define KEISU       10                                      /* 1Loop 10Step                     */
#define WLOOP1      1*MHZ/KEISU+1                           /* LOOP WAIT TIME                   */
#define WLOOP2      2*MHZ/KEISU+1
#define WLOOP4      4*MHZ/KEISU+1
#define WLOOP5      5*MHZ/KEISU+1
#define WLOOP10     10*MHZ/KEISU+1
#define WLOOP20     20*MHZ/KEISU+1
#define WLOOP50     50*MHZ/KEISU+1
#define WLOOP100    100*MHZ/KEISU+1
#define TIME10      10*MHZ/KEISU+1                          /* WRITE WAIT TIME                  */
#define TIME30      30*MHZ/KEISU+1                          /* WRITE WAIT TIME                  */
#define TIME200     200*MHZ/KEISU+1                         /* WRITE WAIT TIME                  */
#define TIME10000   10000*MHZ/KEISU+1                       /* ERASE WAIT TIME                  */
// ----------------------------------------------------------
#define OK          0
#define NG          1
#define WNG         2
#define OW_COUNT    6                                       /* Over Write Count                 */

#define SWE         FLASH.FLMCR1.BIT.SWE                    /* Software Write Enable            */
#define ESU         FLASH.FLMCR1.BIT.ESU                    /* Erase Setup                      */
#define PSU         FLASH.FLMCR1.BIT.PSU                    /* Program Setup                    */
#define EV          FLASH.FLMCR1.BIT.EV                     /* Erase Verify                     */
#define PV          FLASH.FLMCR1.BIT.PV                     /* Program Verify                   */
#define ERS         FLASH.FLMCR1.BIT.E                      /* Erase                            */
#define PGM         FLASH.FLMCR1.BIT.P                      /* Program                          */
#define EBR1        FLASH.EBR1.BYTE						    /* Erase Block Register             */


// ---------------------------------
//   	֐vg^Cv
// ---------------------------------
char fwrite128 ( unsigned char *w_adr, unsigned char *w_buf, unsigned short WT_COUNT );
void mmset(unsigned char *buf, unsigned char c, short sz);
void mmcpy(unsigned char *d,unsigned char *s,short sz);
extern unsigned char rcv1byte ( void );
extern void rcvnbyte ( unsigned short dtno, unsigned char *ram );
extern void trs1byte ( unsigned short tdt );
void wait_t ( unsigned short t );
char fwritevf ( unsigned char *owbuff, unsigned char *buff, unsigned char *w_adr, unsigned char *w_buf );
void flshwrite ( unsigned char *buf, unsigned char *w_adr, unsigned short ptime );

// ------------------------
//  ROM
// ------------------------
int main(void)
{

    char  rtn;
    int		i;
    unsigned char   tmp;
    unsigned char   W_BUF[128];                             /* Write Data Area                  */
    union{
        unsigned char wtdt[8];
        struct{
            unsigned long Address;
            unsigned long Length;
        }lw;
    }rcv;


	SYSCR.BYTE = 0x21;
    set_imask_exr(7);  

	SCKCR.BYTE  = 0x08;	
	LPWRCR.BYTE	 = MHZ_TIMES;

	P3.ODR.BYTE = 0x00;
	P3.DR.BYTE = 0x08;
	P3.DDR = 0x08;

	for( i = 0; i < 20000; i++ ) nop();

    com_init();

/*------- Write Address / Size  Recive --------*/

   	tmp = rcv1byte();           /* Recive Dummy Data    */
	do {
	    trs1byte(0x00);         /* SEND OF OK Code      */
    	tmp = rcv1byte();       /* Recive 1byte 0x88 ?  */
    } while(tmp != 0x88);

    trs1byte(OK);               /* SEND OF OK Code      */

    rcvnbyte(8,rcv.wtdt);       /* Address,Length Receive  */

    if(rcv.wtdt[3] & 0x7F)		/* AhX128Byte̔{ł邱 */
        goto ERRCASE;

    if(rcv.lw.Length == 0x0000){ /* ̓[łȂ */
    	goto ERRCASE;
    }
    trs1byte(OK);               /* SEND OF OK Code     */

/*------- 128 byte Flash Memory Write ---------*/

    while(rcv.lw.Length != 0){

        if(rcv.lw.Length <= 128){ 
            mmset(W_BUF,0xFF,128);  /* INITIALIZE (0xFF)   */
	        trs1byte(0x11);         /* SEND OF Request     */
            rcvnbyte((unsigned short)rcv.lw.Length,W_BUF);
            rcv.lw.Length = 0;
        }
        else{
	        trs1byte(0x11);         /* SEND OF Request     */
            rcvnbyte(128,W_BUF);    /* 128byte Receive     */
            rcv.lw.Length -= 128;
        }

        rtn = fwrite128((unsigned char*)rcv.lw.Address,W_BUF,1000);
        if(rtn != 0)
            goto ERRCASE;

        rcv.lw.Address = rcv.lw.Address + 128;
    }

    trs1byte(OK);                /* SEND OF OK Code       */

    while(1) nop();              /* OK End                */

/*------- Error Case --------------------------*/
ERRCASE:
	trs1byte(NG);
	for( i = 0; i < 20000; i++ ) nop();
	trs1byte(0x60);
	for( i = 0; i < 20000; i++ ) nop();
	trs1byte(0x60);
	for( i = 0; i < 20000; i++ ) nop();
	trs1byte(0x60);
    while(1)   nop();

}

// ---------------------------------
//   	NA
// ---------------------------------
void mmset(unsigned char *buf, unsigned char c, short sz)
{
	for( ; sz > 0; sz-- )
		*buf++ = c;
}
// ---------------------------------
//   	]
// ---------------------------------
void mmcpy(unsigned char *d,unsigned char *s,short sz)
{
	for( ; sz > 0; sz-- )
	{
		*d++ = *s++;
	}
}

// -------------------------------------------
//   	tbVPQWoCg
// -------------------------------------------
char fwrite128 ( unsigned char *w_adr, unsigned char *w_buf, unsigned short WT_COUNT )
{
    char  rtn;
    unsigned short  TM;
    unsigned short  j;
    unsigned char   OWBUFF[128];       	/* Over Write Data Area             */
    unsigned char   BUFF[128];          /* Retry Write Data Area            */

    mmcpy(BUFF,w_buf,128);              /* W_BUF -> BUFF  BLOCK COPY        */
    SWE = 1;                            /* Set the SWE bit                  */
    wait_t(WLOOP1);                     /* Need to wait 1 usec              */

    rtn = fwritevf(OWBUFF,BUFF,w_adr,w_buf); /* 1st Program Verify          */
    if(rtn == NG){                      
        TM = TIME30;
        for(j = 0; j < WT_COUNT; j++){
            flshwrite(BUFF,w_adr,TM);      /* Input P Palse(30 usec)           */
            rtn = fwritevf(OWBUFF,BUFF,w_adr,w_buf);

            if(j < OW_COUNT){           /* Count Check(additive Write Count)*/
                flshwrite(OWBUFF,w_adr,TIME10);
            }
            else{
                TM = TIME200;           /* Input P Palse(200 usec)          */
            }

            if(rtn != NG){
                break;                  /* NG Write Over Error              */
            }
        }
    }

    SWE = 0;                           	/* Clear the SWE bit                */
    wait_t(WLOOP100);                   /* Need to wait 100 usec            */
    return(rtn);
}

// -------------------------------------------
//   	tbV
// -------------------------------------------
void flshwrite ( unsigned char *buf, unsigned char *w_adr, unsigned short ptime )
{
    unsigned char   i;
    volatile unsigned char   j;
    volatile unsigned short  k;

    for(i = 0; i < 128; i++){           /* 128 byte repeat                  */
        w_adr[i] = buf[i];              /* Rewrite data dummy write         */
    }
	WDT0.WRITE.TCSR = 0x5A00;           /* INITIZLIZED WDT COUNT            */
	WDT0.WRITE.RSTCSR = 0x5A5F;			/* WDTȰ	*/
    WDT0.WRITE.TCSR = 0xA57F;           /* WDT START                        */

    PSU = 1;                            /* Set the PSU bit                  */
    for(j = 0; j < WLOOP50; j++) nop(); /* Need to wait 50 usec             */
    PGM = 1;                            /* Set the P bit                    */
    for(k = 0; k < ptime; k++) nop();         /* Writing Time 10/30/200 usec      */

    PGM = 0;                            /* Clear the P bit                  */
    wait_t(WLOOP5);                     /* Need to wait 5 usec              */

    PSU = 0;                            /* Clear the PSU bit                */
    wait_t(WLOOP5);                     /* Need to wait 5 usec              */

    WDT0.WRITE.RSTCSR = 0x5A1F;         /* WDT STOP                         */
}

// -------------------------------------------
//   	tbV xt@C
// -------------------------------------------
char fwritevf ( unsigned char *owbuff, unsigned char *buff, unsigned char *w_adr, unsigned char *w_buf )
{
    volatile unsigned char   i;
    unsigned char   tmp,j;
    char  rtn;

    PV = 1;                             /* Set the PV bit                   */
    for(i = 0; i < WLOOP4; i++);        /* Need to wait 4 usec              */

    for(j = 0; j < 128; j++){
        w_adr[j] = 0xFF;                /* Dummy Write                      */
        for(i = 0; i < WLOOP2; i++);    /* Need to wait 2 usec              */

        owbuff[j] = buff[j] | w_adr[j];

        tmp = ~w_adr[j];
        buff[j] = tmp | w_buf[j];

        tmp = tmp & w_buf[j];           /* Error Check                      */
        if(tmp != 0)
            break;
    }

    PV = 0;                             /* PV bit Clear                     */
    for(i = 0; i < WLOOP2; i++);        /* Need to wait 2 usec              */

    if(tmp == 0){
        rtn = OK;
        for(j = 0; j < 128; j++){       /* 128 byte OK?                     */
            if(buff[j] != 0xFF){        /* Error Check                      */
                rtn = NG;
                break;
            }
        }
    }
    else{
        rtn = WNG;                      /* Write Error                      */
    }

    return(rtn);
}

// -------------------------------------------
//   	WAIT
// -------------------------------------------
void wait_t ( unsigned short t )
{
    while(t--) nop();
}
