// --------------------------------------------------------------------------------
//   H8/2638 fobOvO
//       QlFlTX@H8/300H TinyV[Y@[U[htbV
//                 H8/3664F    RJJ06B0474-0100/Rev.1.00 2004.09
//       RpCF@KPIT Gcc
// --------------------------------------------------------------------------------
#include	"functions.h"
#include 	"2638s.h"

// ---------------------------------
//   	^`
// ---------------------------------
typedef	void			(*Func)(void);

// ---------------------------------
//   	V{
// ---------------------------------
#define OK          0
#define NG          1

// ---------------------------------
//   	֐vg^Cv
// ---------------------------------
void mmset(unsigned char *buf, unsigned char c, short sz);
char mmcpy(unsigned char *d,unsigned char *s,short sz);
extern unsigned char rcv1byte ( void );
extern void rcvnbyte ( unsigned short dtno, unsigned char *ram );
extern void trs1byte ( unsigned short tdt );

// ------------------------
//  ROM
// ------------------------
int main(void)
{

    char  rtn;
    int		i;
    unsigned char   tmp;
    unsigned char   W_BUF[128];                             /* Write Data Area                  */
    union{
        unsigned char wtdt[8];
        struct{
            unsigned long Address;
            unsigned long Length;
        }lw;
    }rcv;


	SYSCR.BYTE = 0x21;
    set_imask_exr(7);  

	SCKCR.BYTE  = 0x08;	
	LPWRCR.BYTE	 = 0x00;

	P3.ODR.BYTE = 0x00;
	P3.DR.BYTE = 0x01;
	P3.DDR = 0x01;

	for( i = 0; i < 20000; i++ ) nop();

    com_init();

/*------- Write Address / Size  Recive --------*/

   	tmp = rcv1byte();           /* Recive Dummy Data    */
	do {
	    trs1byte(0x00);         /* SEND OF OK Code      */
    	tmp = rcv1byte();       /* Recive 1byte 0x88 ?  */
    } while(tmp != 0x88);

    trs1byte(OK);               /* SEND OF OK Code      */

    rcvnbyte(8,rcv.wtdt);       /* Address,Length Receive  */

    if(rcv.wtdt[3] & 0x7F)		/* AhX128Byte̔{ł邱 */
        goto ERRCASE;

    if(rcv.lw.Length == 0x0000){ /* ̓[łȂ */
    	goto ERRCASE;
    }
    trs1byte(OK);               /* SEND OF OK Code     */

/*------- 128 byte Flash Memory Write ---------*/

    while(rcv.lw.Length != 0){

        if(rcv.lw.Length <= 128){ 
            mmset(W_BUF,0xFF,128);  /* INITIALIZE (0xFF)   */
	        trs1byte(0x11);         /* SEND OF Request     */
            rcvnbyte((unsigned short)rcv.lw.Length,W_BUF);
            rcv.lw.Length = 0;
        }
        else{
	        trs1byte(0x11);         /* SEND OF Request     */
            rcvnbyte(128,W_BUF);    /* 128byte Receive     */
            rcv.lw.Length -= 128;
        }

		rtn = mmcpy((unsigned char*)rcv.lw.Address,W_BUF,128);
		if( rtn )	goto ERRCASE;

        rcv.lw.Address = rcv.lw.Address + 128;
    }

    trs1byte(OK);                /* SEND OF OK Code       */

	WDT0.WRITE.TCSR = 0x5A00;    /* INITIZLIZED WDT COUNT */
	WDT0.WRITE.RSTCSR = 0x5A5F;	 /* WDTȰ	*/
    WDT0.WRITE.TCSR = 0xA57F;    /* WDT START   */
    while(1) nop();              /* OK End      */

/*------- Error Case --------------------------*/
ERRCASE:
	trs1byte(NG);
	for( i = 0; i < 20000; i++ ) nop();
	trs1byte(0x60);
	for( i = 0; i < 20000; i++ ) nop();
	trs1byte(0x60);
	for( i = 0; i < 20000; i++ ) nop();
	trs1byte(0x60);
	WDT0.WRITE.TCSR = 0x5A00;    /* INITIZLIZED WDT COUNT */
	WDT0.WRITE.RSTCSR = 0x5A5F;	 /* WDTȰ	*/
    WDT0.WRITE.TCSR = 0xA57F;    /* WDT START   */
    while(1)   nop();

}

// ---------------------------------
//   	NA
// ---------------------------------
void mmset(unsigned char *buf, unsigned char c, short sz)
{
	for( ; sz > 0; sz-- )
		*buf++ = c;
}
// ---------------------------------
//   	]Ɣr
// ---------------------------------
char mmcpy(unsigned char *d,unsigned char *s,short sz)
{
	for( ; sz > 0; sz-- )
	{
		*d = *s;
		if( *d != *s )	return 1;
		d++;
		s++;
	}
	return 0;
}

