// --------------------------------------------------------------------------------
//   H8/2638 SCI-1 M
//       QlFlTX@H8/300H TinyV[Y@[U[htbV
//                 H8/3664F    RJJ06B0474-0100/Rev.1.00 2004.09
//       RpCF@KPIT Gcc
// --------------------------------------------------------------------------------

#include	"functions.h"
#include 	"2638s.h"

// ---------------------------------
//   	֐vg^Cv
// ---------------------------------
void trs1byte ( unsigned short tdt );

// ---------------------------------
//   	V{
// ---------------------------------
#define TXD         P3.DR.BIT.B0      /* TXD                */

// ------------------------
//  SCI-0 I[v4800BPS
// ------------------------
void com_stop ( void )
{
    unsigned short  i;
    unsigned char   tmp;

	MSTP.CRB.BYTE = 0x7F;

	SCI0.SCR.BYTE = 0;
	SCI0.SCMR.BYTE = 0xF2;
	SCI0.SMR.BYTE = 0;
	SCI0.BRR = 129;   		           /* 4800 bps                  */
    for(i = 0; i < 10000; i++) nop();  /* Wait */
	tmp = SCI0.RDR;
	tmp = SCI0.SSR.BYTE;
    SCI0.SSR.BYTE = 0x00;

	SCI0.SCR.BYTE = 0x30;				/* Enable */
    TXD = 1;

}
// ------------------------
//  SCI-0 I[v38400BPS
// ------------------------
void com_init ( void )
{
    unsigned short  i;
    unsigned char   tmp;

	MSTP.CRB.BYTE = 0x7F;

	SCI0.SCR.BYTE = 0;
	SCI0.SCMR.BYTE = 0xF2;
	SCI0.SMR.BYTE = 0;

    SCI0.BRR = 15;  		           /* 38400 bps  */
    for(i = 0; i < 10000; i++) nop();  /* Wait */
	tmp = SCI0.RDR;
	tmp = SCI0.SSR.BYTE;
    SCI0.SSR.BYTE = 0x00;

	SCI0.SCR.BYTE = 0x30;				/* Enable */
    TXD = 1;
}

// ------------------------
//  SCI-0 1oCgM
// ------------------------
unsigned char rcv1byte ( void )
{
    unsigned char   tmp, data;

   	while(SCI0.SSR.BYTE & 0x38)        /* OER/FER/PER = 1 ?  */
	{
		SCI0.SSR.BYTE = 0;
	}
   	while( !(tmp = SCI0.SSR.BIT.RDRF) )	;
	data = SCI0.RDR;
	SCI0.SSR.BIT.RDRF = 0;
    return(data);
}
// ------------------------
//  SCI-0 woCgM
// ------------------------
void rcvnbyte ( unsigned short dtno, unsigned char *ram )
{
    while(dtno--) {          
        *ram++ = rcv1byte();
    }
}

// ------------------------
//  SCI-0 PoCgM
// ------------------------
void trs1byte ( unsigned short tdt )
{
    while(SCI0.SSR.BIT.TDRE == 0) ; 
    SCI0.TDR = (unsigned char)tdt;
    SCI0.SSR.BIT.TDRE = 0;
    while(SCI0.SSR.BIT.TEND == 0) ;
}

// ------------------------
//  SCI-0 woCgM
// ------------------------
void trsnbyte ( unsigned char dtno, unsigned char *tdt )
{
    while(dtno--){
        trs1byte (*tdt++);
    }

}
