// --------------------------------------------------------------------------------
//   H8/2638 SCI-0 M
//       QlFlTX@H8/300H TinyV[Y@[U[htbV
//                 H8/3664F    RJJ06B0474-0100/Rev.1.00 2004.09
//       RpCF@KPIT Gcc
// --------------------------------------------------------------------------------

#include	"functions.h"
#include 	"2638s.h"

// ---------------------------------
//   	֐vg^Cv
// ---------------------------------
void 	SCI0_rx_interrupt(void) __attribute__ ((interrupt_handler));
void 	SCI0_err_interrupt(void) __attribute__ ((interrupt_handler));
void trs1byte ( unsigned short tdt );

// ---------------------------------
//   	V{
// ---------------------------------
#define TXD         P3.DR.BIT.B0      /* TXD                */

// ---------------------------------
//   	ƈ
// ---------------------------------
unsigned char data;

// ------------------------
//  SCI-0 I[v38400BPS
// ------------------------
void com_init ( void )
{
    unsigned short  i;
    unsigned char   tmp;

	MSTP.CRB.BYTE = 0x7F;

	SCI0.SCR.BYTE = 0;
	SCI0.SCMR.BYTE = 0xF2;
	SCI0.SMR.BYTE = 0;

    SCI0.BRR = 15;      		       /* 38400 bps  */
    for(i = 0; i < 10000; i++) nop();  /* Wait */
	tmp = SCI0.RDR;
	tmp = SCI0.SSR.BYTE;
    SCI0.SSR.BYTE = 0x00;

	SCI0.SCR.BYTE = 0x30;				/* Enable */
	SCI0.SCR.BIT.RIE = 1;
	INTC.IPRJ.BYTE = 0x02;
    TXD = 1;
}

// ------------------------
//  SCI-0 1oCgM
// ------------------------
unsigned char rcv1byte ( void )
{
    unsigned char   tmp, data;

   	while(SCI0.SSR.BYTE & 0x38)        /* OER/FER/PER = 1 ?  */
	{
		SCI0.SSR.BYTE = 0;
	}
   	while( !(tmp = SCI0.SSR.BIT.RDRF) )	;
	data = SCI0.RDR;
	SCI0.SSR.BIT.RDRF = 0;
    return(data);
}

// ------------------------
//  SCI-0 PoCgM
// ------------------------
void trs1byte ( unsigned short tdt )
{
    while(SCI0.SSR.BIT.TDRE == 0) ; 
    SCI0.TDR = (unsigned char)tdt;
    SCI0.SSR.BIT.TDRE = 0;
    while(SCI0.SSR.BIT.TEND == 0) ;
}
// ------------------------
//  SCI-0 Mf[^擾
// ------------------------
unsigned char get1byte ( void )
{
    unsigned char w;
	
	w = data;
	data = 0;
	return w;
}
// ------------------------
//  SCI-0 M
// ------------------------
void SCI0_rx_interrupt(void)
{
	unsigned char dmy;

	data = SCI0.RDR;
	dmy = SCI0.SSR.BIT.RDRF;
	SCI0.SSR.BIT.RDRF = 0;

}
// ------------------------
//  SCI-0 G[M
// ------------------------
void SCI0_err_interrupt(void)
{
	SCI0.SSR.BIT.ORER = 0;
	SCI0.SSR.BIT.FER = 0;
	SCI0.SSR.BIT.PER = 0;

	if (SCI0.SSR.BIT.RDRF != 0) {
		SCI0.SSR.BIT.RDRF = 0;
	}
}

